﻿<%@ WebHandler Language="C#" Class="SearchSuggestion" %>

using System;
using System.IO;
using System.Text;
using System.Web;
using System.Linq;
using System.Web.UI.WebControls;
using System.Xml;

public class SearchSuggestion : IHttpHandler {
    
    public void ProcessRequest (HttpContext context) {
        context.Response.ContentType = "text/plain";
        var q = context.Request["query"];
        if (q==null) q = "";
        DataClassesDataContext dcdc = new DataClassesDataContext("Data Source=localhost;Initial Catalog=AdventureWorks;Integrated Security=True");

        var query = from p in dcdc.Products where p.Name.Contains(q) select p;
        query = query.Take(10);
        var sb = new StringBuilder();

        MemoryStream ms = new MemoryStream();
        string str = "";
        XmlTextWriter writer = new XmlTextWriter(ms, Encoding.UTF8);
        writer.WriteStartDocument();
        writer.WriteStartElement("SearchSuggestion");
        writer.WriteAttributeString("version","2.0");
        writer.WriteAttributeString("xmlns",null, null, "http://opensearch.org/searchsuggest2");
        writer.WriteStartElement("Query");
        writer.WriteAttributeString("xml", "space",null, "preserve");
        writer.WriteValue(q);
        writer.WriteEndElement();
        writer.WriteStartElement("Section");
        foreach (Product p in query)
        {
            writer.WriteStartElement("Item");
            writer.WriteStartElement("Text");
            writer.WriteAttributeString("xml", "space", null, "preserve");
            writer.WriteValue(p.Name);
            writer.WriteEndElement();
            
            writer.WriteStartElement("Url");
            writer.WriteAttributeString("xml", "space", null, "preserve");
            writer.WriteValue("http://localhost:31770/AWCDShop/products/ProductsSearch.aspx?query="+p.Name);
            writer.WriteEndElement();
            
            writer.WriteStartElement("Description");
            writer.WriteAttributeString("xml", "space", null, "preserve");
            writer.WriteValue((p.ProductModel != null &&
                            p.ProductModel.ProductModelProductDescriptionCultures.Count > 0)
                               ? p.ProductModel.ProductModelProductDescriptionCultures[0].ProductDescription.
                                     Description
                               : "");
            writer.WriteEndElement();

            writer.WriteStartElement("Image");
            writer.WriteAttributeString("xml", "space", null, "preserve");
            writer.WriteAttributeString("width", "80");
            writer.WriteAttributeString("height", "49");
            writer.WriteAttributeString("align", "middle");
            writer.WriteAttributeString("source", "http://localhost:31770/AWCDShop/products/images/ProductImages/thumbs/" +
                                p.ProductProductPhotos[0].ProductPhoto.ThumbnailPhotoFileName);
            writer.WriteEndElement();
            
            writer.WriteEndElement();
        }
        writer.WriteEndElement();
        writer.WriteEndElement();
        writer.WriteEndDocument();
        writer.Flush();
        ms.Position = 0;
        var sr = new StreamReader(ms);

        context.Response.Write(sr.ReadToEnd());
    }
 
    public bool IsReusable {
        get {
            return true;
        }
    }

}