﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class products_ProductControl : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        Visible = false;    
    }

    public void LoadContent(Product p)
    {
        Visible = true;
        Session["ViewProduct"] = p.ProductID;

        description.Text = (p.ProductModel != null &&
                            p.ProductModel.ProductModelProductDescriptionCultures.Count > 0)
                               ? p.ProductModel.ProductModelProductDescriptionCultures[0].ProductDescription.
                                     Description
                               : "";
        UnitCost.Text = p.ListPrice.ToString("F2");
        ModelName.Text = p.ProductModel != null ? p.ProductModel.Name : "";
        ProductNumber.Text = p.ProductNumber.ToString(CultureInfo.InvariantCulture);
        ProductImage.ImageUrl = "~/products/images/ProductImages/" +
                                p.ProductProductPhotos[0].ProductPhoto.LargePhotoFileName;
        ReviewList.DataSource = null;
        ReviewList.DataSource = p.ProductReviews;
        ReviewList.DataBind();

        Comment.Text = "";
        Email.Text = "";
        Rating5.Checked = true;
        Name.Text = "";
    }


    protected void OnClick(object sender, EventArgs e)
    {
        DataClassesDataContext dcdc =
                new DataClassesDataContext(
                    "Data Source=localhost;Initial Catalog=AdventureWorks;Integrated Security=True");
        var product = dcdc.Products.Single(p => p.ProductID == (int)Session["ViewProduct"]);

        ProductReview pr = new ProductReview();
        pr.Comments = Comment.Text;
        pr.EmailAddress = Email.Text;
        if (Rating1.Checked)
        {
            pr.Rating = 1;
        }
        if (Rating2.Checked)
        {
            pr.Rating = 2;
        }
        if (Rating3.Checked)
        {
            pr.Rating = 3;
        }
        if (Rating4.Checked)
        {
            pr.Rating = 4;
        }
        if (Rating5.Checked)
        {
            pr.Rating = 5;
        }
        pr.ReviewDate = DateTime.Now;
        pr.ModifiedDate = DateTime.Now;
        pr.ReviewerName = Name.Text;

        product.ProductReviews.Add(pr);
        dcdc.SubmitChanges();
       
        LoadContent(product);
    }
}